<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCalendarAvailType ArrayType
 * @subpackage Arrays
 */
class ArrayOfCalendarAvailType extends AbstractStructArrayBase
{
    /**
     * The CalendarAvail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CalendarAvailType[]
     */
    public $CalendarAvail;
    /**
     * Constructor method for ArrayOfCalendarAvailType
     * @uses ArrayOfCalendarAvailType::setCalendarAvail()
     * @param \StructType\CalendarAvailType[] $calendarAvail
     */
    public function __construct(array $calendarAvail = array())
    {
        $this
            ->setCalendarAvail($calendarAvail);
    }
    /**
     * Get CalendarAvail value
     * @return \StructType\CalendarAvailType[]|null
     */
    public function getCalendarAvail()
    {
        return $this->CalendarAvail;
    }
    /**
     * Set CalendarAvail value
     * @throws \InvalidArgumentException
     * @param \StructType\CalendarAvailType[] $calendarAvail
     * @return \ArrayType\ArrayOfCalendarAvailType
     */
    public function setCalendarAvail(array $calendarAvail = array())
    {
        foreach ($calendarAvail as $arrayOfCalendarAvailTypeCalendarAvailItem) {
            // validation for constraint: itemType
            if (!$arrayOfCalendarAvailTypeCalendarAvailItem instanceof \StructType\CalendarAvailType) {
                throw new \InvalidArgumentException(sprintf('The CalendarAvail property can only contain items of \StructType\CalendarAvailType, "%s" given', is_object($arrayOfCalendarAvailTypeCalendarAvailItem) ? get_class($arrayOfCalendarAvailTypeCalendarAvailItem) : gettype($arrayOfCalendarAvailTypeCalendarAvailItem)), __LINE__);
            }
        }
        $this->CalendarAvail = $calendarAvail;
        return $this;
    }
    /**
     * Add item to CalendarAvail value
     * @throws \InvalidArgumentException
     * @param \StructType\CalendarAvailType $item
     * @return \ArrayType\ArrayOfCalendarAvailType
     */
    public function addToCalendarAvail(\StructType\CalendarAvailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CalendarAvailType) {
            throw new \InvalidArgumentException(sprintf('The CalendarAvail property can only contain items of \StructType\CalendarAvailType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CalendarAvail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CalendarAvailType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CalendarAvailType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CalendarAvailType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CalendarAvailType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CalendarAvailType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CalendarAvail
     */
    public function getAttributeName()
    {
        return 'CalendarAvail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCalendarAvailType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
