<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDamageWaiverOptionType ArrayType
 * @subpackage Arrays
 */
class ArrayOfDamageWaiverOptionType extends AbstractStructArrayBase
{
    /**
     * The DamageWaiverOption
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DamageWaiverOptionType[]
     */
    public $DamageWaiverOption;
    /**
     * Constructor method for ArrayOfDamageWaiverOptionType
     * @uses ArrayOfDamageWaiverOptionType::setDamageWaiverOption()
     * @param \StructType\DamageWaiverOptionType[] $damageWaiverOption
     */
    public function __construct(array $damageWaiverOption = array())
    {
        $this
            ->setDamageWaiverOption($damageWaiverOption);
    }
    /**
     * Get DamageWaiverOption value
     * @return \StructType\DamageWaiverOptionType[]|null
     */
    public function getDamageWaiverOption()
    {
        return $this->DamageWaiverOption;
    }
    /**
     * Set DamageWaiverOption value
     * @throws \InvalidArgumentException
     * @param \StructType\DamageWaiverOptionType[] $damageWaiverOption
     * @return \ArrayType\ArrayOfDamageWaiverOptionType
     */
    public function setDamageWaiverOption(array $damageWaiverOption = array())
    {
        foreach ($damageWaiverOption as $arrayOfDamageWaiverOptionTypeDamageWaiverOptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfDamageWaiverOptionTypeDamageWaiverOptionItem instanceof \StructType\DamageWaiverOptionType) {
                throw new \InvalidArgumentException(sprintf('The DamageWaiverOption property can only contain items of \StructType\DamageWaiverOptionType, "%s" given', is_object($arrayOfDamageWaiverOptionTypeDamageWaiverOptionItem) ? get_class($arrayOfDamageWaiverOptionTypeDamageWaiverOptionItem) : gettype($arrayOfDamageWaiverOptionTypeDamageWaiverOptionItem)), __LINE__);
            }
        }
        $this->DamageWaiverOption = $damageWaiverOption;
        return $this;
    }
    /**
     * Add item to DamageWaiverOption value
     * @throws \InvalidArgumentException
     * @param \StructType\DamageWaiverOptionType $item
     * @return \ArrayType\ArrayOfDamageWaiverOptionType
     */
    public function addToDamageWaiverOption(\StructType\DamageWaiverOptionType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DamageWaiverOptionType) {
            throw new \InvalidArgumentException(sprintf('The DamageWaiverOption property can only contain items of \StructType\DamageWaiverOptionType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DamageWaiverOption[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DamageWaiverOptionType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DamageWaiverOptionType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DamageWaiverOptionType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DamageWaiverOptionType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DamageWaiverOptionType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DamageWaiverOption
     */
    public function getAttributeName()
    {
        return 'DamageWaiverOption';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDamageWaiverOptionType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
