<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEVRN_AmountType ArrayType
 * @subpackage Arrays
 */
class ArrayOfEVRN_AmountType extends AbstractStructArrayBase
{
    /**
     * The Rate
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EVRN_AmountType[]
     */
    public $Rate;
    /**
     * Constructor method for ArrayOfEVRN_AmountType
     * @uses ArrayOfEVRN_AmountType::setRate()
     * @param \StructType\EVRN_AmountType[] $rate
     */
    public function __construct(array $rate = array())
    {
        $this
            ->setRate($rate);
    }
    /**
     * Get Rate value
     * @return \StructType\EVRN_AmountType[]|null
     */
    public function getRate()
    {
        return $this->Rate;
    }
    /**
     * Set Rate value
     * @throws \InvalidArgumentException
     * @param \StructType\EVRN_AmountType[] $rate
     * @return \ArrayType\ArrayOfEVRN_AmountType
     */
    public function setRate(array $rate = array())
    {
        foreach ($rate as $arrayOfEVRN_AmountTypeRateItem) {
            // validation for constraint: itemType
            if (!$arrayOfEVRN_AmountTypeRateItem instanceof \StructType\EVRN_AmountType) {
                throw new \InvalidArgumentException(sprintf('The Rate property can only contain items of \StructType\EVRN_AmountType, "%s" given', is_object($arrayOfEVRN_AmountTypeRateItem) ? get_class($arrayOfEVRN_AmountTypeRateItem) : gettype($arrayOfEVRN_AmountTypeRateItem)), __LINE__);
            }
        }
        $this->Rate = $rate;
        return $this;
    }
    /**
     * Add item to Rate value
     * @throws \InvalidArgumentException
     * @param \StructType\EVRN_AmountType $item
     * @return \ArrayType\ArrayOfEVRN_AmountType
     */
    public function addToRate(\StructType\EVRN_AmountType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EVRN_AmountType) {
            throw new \InvalidArgumentException(sprintf('The Rate property can only contain items of \StructType\EVRN_AmountType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Rate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EVRN_AmountType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EVRN_AmountType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EVRN_AmountType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EVRN_AmountType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EVRN_AmountType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Rate
     */
    public function getAttributeName()
    {
        return 'Rate';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEVRN_AmountType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
