<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRateRangeType ArrayType
 * @subpackage Arrays
 */
class ArrayOfRateRangeType extends AbstractStructArrayBase
{
    /**
     * The RateRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RateRangeType[]
     */
    public $RateRange;
    /**
     * Constructor method for ArrayOfRateRangeType
     * @uses ArrayOfRateRangeType::setRateRange()
     * @param \StructType\RateRangeType[] $rateRange
     */
    public function __construct(array $rateRange = array())
    {
        $this
            ->setRateRange($rateRange);
    }
    /**
     * Get RateRange value
     * @return \StructType\RateRangeType[]|null
     */
    public function getRateRange()
    {
        return $this->RateRange;
    }
    /**
     * Set RateRange value
     * @throws \InvalidArgumentException
     * @param \StructType\RateRangeType[] $rateRange
     * @return \ArrayType\ArrayOfRateRangeType
     */
    public function setRateRange(array $rateRange = array())
    {
        foreach ($rateRange as $arrayOfRateRangeTypeRateRangeItem) {
            // validation for constraint: itemType
            if (!$arrayOfRateRangeTypeRateRangeItem instanceof \StructType\RateRangeType) {
                throw new \InvalidArgumentException(sprintf('The RateRange property can only contain items of \StructType\RateRangeType, "%s" given', is_object($arrayOfRateRangeTypeRateRangeItem) ? get_class($arrayOfRateRangeTypeRateRangeItem) : gettype($arrayOfRateRangeTypeRateRangeItem)), __LINE__);
            }
        }
        $this->RateRange = $rateRange;
        return $this;
    }
    /**
     * Add item to RateRange value
     * @throws \InvalidArgumentException
     * @param \StructType\RateRangeType $item
     * @return \ArrayType\ArrayOfRateRangeType
     */
    public function addToRateRange(\StructType\RateRangeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RateRangeType) {
            throw new \InvalidArgumentException(sprintf('The RateRange property can only contain items of \StructType\RateRangeType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RateRange[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RateRangeType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RateRangeType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RateRangeType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RateRangeType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RateRangeType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RateRange
     */
    public function getAttributeName()
    {
        return 'RateRange';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRateRangeType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
