<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReservationUpdateUnitRate ArrayType
 * @subpackage Arrays
 */
class ArrayOfReservationUpdateUnitRate extends AbstractStructArrayBase
{
    /**
     * The UnitRate
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UnitRate[]
     */
    public $UnitRate;
    /**
     * Constructor method for ArrayOfReservationUpdateUnitRate
     * @uses ArrayOfReservationUpdateUnitRate::setUnitRate()
     * @param \StructType\UnitRate[] $unitRate
     */
    public function __construct(array $unitRate = array())
    {
        $this
            ->setUnitRate($unitRate);
    }
    /**
     * Get UnitRate value
     * @return \StructType\UnitRate[]|null
     */
    public function getUnitRate()
    {
        return $this->UnitRate;
    }
    /**
     * Set UnitRate value
     * @throws \InvalidArgumentException
     * @param \StructType\UnitRate[] $unitRate
     * @return \ArrayType\ArrayOfReservationUpdateUnitRate
     */
    public function setUnitRate(array $unitRate = array())
    {
        foreach ($unitRate as $arrayOfReservationUpdateUnitRateUnitRateItem) {
            // validation for constraint: itemType
            if (!$arrayOfReservationUpdateUnitRateUnitRateItem instanceof \StructType\UnitRate) {
                throw new \InvalidArgumentException(sprintf('The UnitRate property can only contain items of \StructType\UnitRate, "%s" given', is_object($arrayOfReservationUpdateUnitRateUnitRateItem) ? get_class($arrayOfReservationUpdateUnitRateUnitRateItem) : gettype($arrayOfReservationUpdateUnitRateUnitRateItem)), __LINE__);
            }
        }
        $this->UnitRate = $unitRate;
        return $this;
    }
    /**
     * Add item to UnitRate value
     * @throws \InvalidArgumentException
     * @param \StructType\UnitRate $item
     * @return \ArrayType\ArrayOfReservationUpdateUnitRate
     */
    public function addToUnitRate(\StructType\UnitRate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UnitRate) {
            throw new \InvalidArgumentException(sprintf('The UnitRate property can only contain items of \StructType\UnitRate, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UnitRate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UnitRate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UnitRate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UnitRate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UnitRate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UnitRate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UnitRate
     */
    public function getAttributeName()
    {
        return 'UnitRate';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfReservationUpdateUnitRate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
