<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRoutingHopTypeRoutingHop ArrayType
 * @subpackage Arrays
 */
class ArrayOfRoutingHopTypeRoutingHop extends AbstractStructArrayBase
{
    /**
     * The RoutingHop
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RoutingHop[]
     */
    public $RoutingHop;
    /**
     * Constructor method for ArrayOfRoutingHopTypeRoutingHop
     * @uses ArrayOfRoutingHopTypeRoutingHop::setRoutingHop()
     * @param \StructType\RoutingHop[] $routingHop
     */
    public function __construct(array $routingHop = array())
    {
        $this
            ->setRoutingHop($routingHop);
    }
    /**
     * Get RoutingHop value
     * @return \StructType\RoutingHop[]|null
     */
    public function getRoutingHop()
    {
        return $this->RoutingHop;
    }
    /**
     * Set RoutingHop value
     * @throws \InvalidArgumentException
     * @param \StructType\RoutingHop[] $routingHop
     * @return \ArrayType\ArrayOfRoutingHopTypeRoutingHop
     */
    public function setRoutingHop(array $routingHop = array())
    {
        foreach ($routingHop as $arrayOfRoutingHopTypeRoutingHopRoutingHopItem) {
            // validation for constraint: itemType
            if (!$arrayOfRoutingHopTypeRoutingHopRoutingHopItem instanceof \StructType\RoutingHop) {
                throw new \InvalidArgumentException(sprintf('The RoutingHop property can only contain items of \StructType\RoutingHop, "%s" given', is_object($arrayOfRoutingHopTypeRoutingHopRoutingHopItem) ? get_class($arrayOfRoutingHopTypeRoutingHopRoutingHopItem) : gettype($arrayOfRoutingHopTypeRoutingHopRoutingHopItem)), __LINE__);
            }
        }
        $this->RoutingHop = $routingHop;
        return $this;
    }
    /**
     * Add item to RoutingHop value
     * @throws \InvalidArgumentException
     * @param \StructType\RoutingHop $item
     * @return \ArrayType\ArrayOfRoutingHopTypeRoutingHop
     */
    public function addToRoutingHop(\StructType\RoutingHop $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoutingHop) {
            throw new \InvalidArgumentException(sprintf('The RoutingHop property can only contain items of \StructType\RoutingHop, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RoutingHop[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RoutingHop|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RoutingHop|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RoutingHop|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RoutingHop|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RoutingHop|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoutingHop
     */
    public function getAttributeName()
    {
        return 'RoutingHop';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRoutingHopTypeRoutingHop
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
