<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUnitReservationIDsTypeUnitReservationID ArrayType
 * @subpackage Arrays
 */
class ArrayOfUnitReservationIDsTypeUnitReservationID extends AbstractStructArrayBase
{
    /**
     * The UnitReservationID
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UnitReservationID[]
     */
    public $UnitReservationID;
    /**
     * Constructor method for ArrayOfUnitReservationIDsTypeUnitReservationID
     * @uses ArrayOfUnitReservationIDsTypeUnitReservationID::setUnitReservationID()
     * @param \StructType\UnitReservationID[] $unitReservationID
     */
    public function __construct(array $unitReservationID = array())
    {
        $this
            ->setUnitReservationID($unitReservationID);
    }
    /**
     * Get UnitReservationID value
     * @return \StructType\UnitReservationID[]|null
     */
    public function getUnitReservationID()
    {
        return $this->UnitReservationID;
    }
    /**
     * Set UnitReservationID value
     * @throws \InvalidArgumentException
     * @param \StructType\UnitReservationID[] $unitReservationID
     * @return \ArrayType\ArrayOfUnitReservationIDsTypeUnitReservationID
     */
    public function setUnitReservationID(array $unitReservationID = array())
    {
        foreach ($unitReservationID as $arrayOfUnitReservationIDsTypeUnitReservationIDUnitReservationIDItem) {
            // validation for constraint: itemType
            if (!$arrayOfUnitReservationIDsTypeUnitReservationIDUnitReservationIDItem instanceof \StructType\UnitReservationID) {
                throw new \InvalidArgumentException(sprintf('The UnitReservationID property can only contain items of \StructType\UnitReservationID, "%s" given', is_object($arrayOfUnitReservationIDsTypeUnitReservationIDUnitReservationIDItem) ? get_class($arrayOfUnitReservationIDsTypeUnitReservationIDUnitReservationIDItem) : gettype($arrayOfUnitReservationIDsTypeUnitReservationIDUnitReservationIDItem)), __LINE__);
            }
        }
        $this->UnitReservationID = $unitReservationID;
        return $this;
    }
    /**
     * Add item to UnitReservationID value
     * @throws \InvalidArgumentException
     * @param \StructType\UnitReservationID $item
     * @return \ArrayType\ArrayOfUnitReservationIDsTypeUnitReservationID
     */
    public function addToUnitReservationID(\StructType\UnitReservationID $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UnitReservationID) {
            throw new \InvalidArgumentException(sprintf('The UnitReservationID property can only contain items of \StructType\UnitReservationID, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UnitReservationID[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UnitReservationID|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UnitReservationID|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UnitReservationID|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UnitReservationID|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UnitReservationID|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UnitReservationID
     */
    public function getAttributeName()
    {
        return 'UnitReservationID';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfUnitReservationIDsTypeUnitReservationID
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
