<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CampaignKeywordReferralType StructType
 * @subpackage Structs
 */
class CampaignKeywordReferralType extends AbstractStructBase
{
    /**
     * The ReferralHost
     * @var string
     */
    public $ReferralHost;
    /**
     * The KeywordName
     * @var string
     */
    public $KeywordName;
    /**
     * The KeywordValue
     * @var string
     */
    public $KeywordValue;
    /**
     * Constructor method for CampaignKeywordReferralType
     * @uses CampaignKeywordReferralType::setReferralHost()
     * @uses CampaignKeywordReferralType::setKeywordName()
     * @uses CampaignKeywordReferralType::setKeywordValue()
     * @param string $referralHost
     * @param string $keywordName
     * @param string $keywordValue
     */
    public function __construct($referralHost = null, $keywordName = null, $keywordValue = null)
    {
        $this
            ->setReferralHost($referralHost)
            ->setKeywordName($keywordName)
            ->setKeywordValue($keywordValue);
    }
    /**
     * Get ReferralHost value
     * @return string|null
     */
    public function getReferralHost()
    {
        return $this->ReferralHost;
    }
    /**
     * Set ReferralHost value
     * @param string $referralHost
     * @return \StructType\CampaignKeywordReferralType
     */
    public function setReferralHost($referralHost = null)
    {
        // validation for constraint: string
        if (!is_null($referralHost) && !is_string($referralHost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($referralHost)), __LINE__);
        }
        $this->ReferralHost = $referralHost;
        return $this;
    }
    /**
     * Get KeywordName value
     * @return string|null
     */
    public function getKeywordName()
    {
        return $this->KeywordName;
    }
    /**
     * Set KeywordName value
     * @param string $keywordName
     * @return \StructType\CampaignKeywordReferralType
     */
    public function setKeywordName($keywordName = null)
    {
        // validation for constraint: string
        if (!is_null($keywordName) && !is_string($keywordName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($keywordName)), __LINE__);
        }
        $this->KeywordName = $keywordName;
        return $this;
    }
    /**
     * Get KeywordValue value
     * @return string|null
     */
    public function getKeywordValue()
    {
        return $this->KeywordValue;
    }
    /**
     * Set KeywordValue value
     * @param string $keywordValue
     * @return \StructType\CampaignKeywordReferralType
     */
    public function setKeywordValue($keywordValue = null)
    {
        // validation for constraint: string
        if (!is_null($keywordValue) && !is_string($keywordValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($keywordValue)), __LINE__);
        }
        $this->KeywordValue = $keywordValue;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CampaignKeywordReferralType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
