<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EVRN_UnitCalendarAvailRQ StructType
 * @subpackage Structs
 */
class EVRN_UnitCalendarAvailRQ extends EVRN_BaseRQType
{
    /**
     * The UnitRef
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\UnitRef
     */
    public $UnitRef;
    /**
     * The CalendarDateRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeSpanType
     */
    public $CalendarDateRange;
    /**
     * The ShowHolds
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ShowHolds;
    /**
     * Constructor method for EVRN_UnitCalendarAvailRQ
     * @uses EVRN_UnitCalendarAvailRQ::setUnitRef()
     * @uses EVRN_UnitCalendarAvailRQ::setCalendarDateRange()
     * @uses EVRN_UnitCalendarAvailRQ::setShowHolds()
     * @param \StructType\UnitRef $unitRef
     * @param \StructType\DateTimeSpanType $calendarDateRange
     * @param string $showHolds
     */
    public function __construct(\StructType\UnitRef $unitRef = null, \StructType\DateTimeSpanType $calendarDateRange = null, $showHolds = null)
    {
        $this
            ->setUnitRef($unitRef)
            ->setCalendarDateRange($calendarDateRange)
            ->setShowHolds($showHolds);
    }
    /**
     * Get UnitRef value
     * @return \StructType\UnitRef|null
     */
    public function getUnitRef()
    {
        return $this->UnitRef;
    }
    /**
     * Set UnitRef value
     * @param \StructType\UnitRef $unitRef
     * @return \StructType\EVRN_UnitCalendarAvailRQ
     */
    public function setUnitRef(\StructType\UnitRef $unitRef = null)
    {
        $this->UnitRef = $unitRef;
        return $this;
    }
    /**
     * Get CalendarDateRange value
     * @return \StructType\DateTimeSpanType|null
     */
    public function getCalendarDateRange()
    {
        return $this->CalendarDateRange;
    }
    /**
     * Set CalendarDateRange value
     * @param \StructType\DateTimeSpanType $calendarDateRange
     * @return \StructType\EVRN_UnitCalendarAvailRQ
     */
    public function setCalendarDateRange(\StructType\DateTimeSpanType $calendarDateRange = null)
    {
        $this->CalendarDateRange = $calendarDateRange;
        return $this;
    }
    /**
     * Get ShowHolds value
     * @return string|null
     */
    public function getShowHolds()
    {
        return $this->ShowHolds;
    }
    /**
     * Set ShowHolds value
     * @param string $showHolds
     * @return \StructType\EVRN_UnitCalendarAvailRQ
     */
    public function setShowHolds($showHolds = null)
    {
        // validation for constraint: string
        if (!is_null($showHolds) && !is_string($showHolds)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($showHolds)), __LINE__);
        }
        $this->ShowHolds = $showHolds;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EVRN_UnitCalendarAvailRQ
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
