<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EVRN_UnitSearchRS StructType
 * @subpackage Structs
 */
class EVRN_UnitSearchRS extends EVRN_BaseRSType
{
    /**
     * The Errors
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ErrorsType
     */
    public $Errors;
    /**
     * The Units
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Units
     */
    public $Units;
    /**
     * The Areas
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Areas
     */
    public $Areas;
    /**
     * The Success
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SuccessType
     */
    public $Success;
    /**
     * The Warnings
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\WarningsType
     */
    public $Warnings;
    /**
     * The TPA_Extensions
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TPA_Extensions_Type
     */
    public $TPA_Extensions;
    /**
     * The Criteria
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\UnitSearchCriteriaType
     */
    public $Criteria;
    /**
     * Constructor method for EVRN_UnitSearchRS
     * @uses EVRN_UnitSearchRS::setErrors()
     * @uses EVRN_UnitSearchRS::setUnits()
     * @uses EVRN_UnitSearchRS::setAreas()
     * @uses EVRN_UnitSearchRS::setSuccess()
     * @uses EVRN_UnitSearchRS::setWarnings()
     * @uses EVRN_UnitSearchRS::setTPA_Extensions()
     * @uses EVRN_UnitSearchRS::setCriteria()
     * @param \StructType\ErrorsType $errors
     * @param \StructType\Units $units
     * @param \StructType\Areas $areas
     * @param \StructType\SuccessType $success
     * @param \StructType\WarningsType $warnings
     * @param \StructType\TPA_Extensions_Type $tPA_Extensions
     * @param \StructType\UnitSearchCriteriaType $criteria
     */
    public function __construct(\StructType\ErrorsType $errors = null, \StructType\Units $units = null, \StructType\Areas $areas = null, \StructType\SuccessType $success = null, \StructType\WarningsType $warnings = null, \StructType\TPA_Extensions_Type $tPA_Extensions = null, \StructType\UnitSearchCriteriaType $criteria = null)
    {
        $this
            ->setErrors($errors)
            ->setUnits($units)
            ->setAreas($areas)
            ->setSuccess($success)
            ->setWarnings($warnings)
            ->setTPA_Extensions($tPA_Extensions)
            ->setCriteria($criteria);
    }
    /**
     * Get Errors value
     * @return \StructType\ErrorsType|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \StructType\ErrorsType $errors
     * @return \StructType\EVRN_UnitSearchRS
     */
    public function setErrors(\StructType\ErrorsType $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Get Units value
     * @return \StructType\Units|null
     */
    public function getUnits()
    {
        return $this->Units;
    }
    /**
     * Set Units value
     * @param \StructType\Units $units
     * @return \StructType\EVRN_UnitSearchRS
     */
    public function setUnits(\StructType\Units $units = null)
    {
        $this->Units = $units;
        return $this;
    }
    /**
     * Get Areas value
     * @return \StructType\Areas|null
     */
    public function getAreas()
    {
        return $this->Areas;
    }
    /**
     * Set Areas value
     * @param \StructType\Areas $areas
     * @return \StructType\EVRN_UnitSearchRS
     */
    public function setAreas(\StructType\Areas $areas = null)
    {
        $this->Areas = $areas;
        return $this;
    }
    /**
     * Get Success value
     * @return \StructType\SuccessType|null
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param \StructType\SuccessType $success
     * @return \StructType\EVRN_UnitSearchRS
     */
    public function setSuccess(\StructType\SuccessType $success = null)
    {
        $this->Success = $success;
        return $this;
    }
    /**
     * Get Warnings value
     * @return \StructType\WarningsType|null
     */
    public function getWarnings()
    {
        return $this->Warnings;
    }
    /**
     * Set Warnings value
     * @param \StructType\WarningsType $warnings
     * @return \StructType\EVRN_UnitSearchRS
     */
    public function setWarnings(\StructType\WarningsType $warnings = null)
    {
        $this->Warnings = $warnings;
        return $this;
    }
    /**
     * Get TPA_Extensions value
     * @return \StructType\TPA_Extensions_Type|null
     */
    public function getTPA_Extensions()
    {
        return $this->TPA_Extensions;
    }
    /**
     * Set TPA_Extensions value
     * @param \StructType\TPA_Extensions_Type $tPA_Extensions
     * @return \StructType\EVRN_UnitSearchRS
     */
    public function setTPA_Extensions(\StructType\TPA_Extensions_Type $tPA_Extensions = null)
    {
        $this->TPA_Extensions = $tPA_Extensions;
        return $this;
    }
    /**
     * Get Criteria value
     * @return \StructType\UnitSearchCriteriaType|null
     */
    public function getCriteria()
    {
        return $this->Criteria;
    }
    /**
     * Set Criteria value
     * @param \StructType\UnitSearchCriteriaType $criteria
     * @return \StructType\EVRN_UnitSearchRS
     */
    public function setCriteria(\StructType\UnitSearchCriteriaType $criteria = null)
    {
        $this->Criteria = $criteria;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EVRN_UnitSearchRS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
