<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EquipmentTypePref StructType
 * @subpackage Structs
 */
class EquipmentTypePref extends EquipmentType
{
    /**
     * The _
     * @var \StructType\EquipmentType
     */
    public $_;
    /**
     * The PreferLevel
     * Meta informations extracted from the WSDL
     * - default: Preferred
     * @var string
     */
    public $PreferLevel;
    /**
     * The WideBody
     * @var bool
     */
    public $WideBody;
    /**
     * Constructor method for EquipmentTypePref
     * @uses EquipmentTypePref::set_()
     * @uses EquipmentTypePref::setPreferLevel()
     * @uses EquipmentTypePref::setWideBody()
     * @param \StructType\EquipmentType $_
     * @param string $preferLevel
     * @param bool $wideBody
     */
    public function __construct(\StructType\EquipmentType $_ = null, $preferLevel = 'Preferred', $wideBody = null)
    {
        $this
            ->set_($_)
            ->setPreferLevel($preferLevel)
            ->setWideBody($wideBody);
    }
    /**
     * Get _ value
     * @return \StructType\EquipmentType|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param \StructType\EquipmentType $_
     * @return \StructType\EquipmentTypePref
     */
    public function set_(\StructType\EquipmentType $_ = null)
    {
        $this->_ = $_;
        return $this;
    }
    /**
     * Get PreferLevel value
     * @return string|null
     */
    public function getPreferLevel()
    {
        return $this->PreferLevel;
    }
    /**
     * Set PreferLevel value
     * @uses \EnumType\PreferLevelType::valueIsValid()
     * @uses \EnumType\PreferLevelType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $preferLevel
     * @return \StructType\EquipmentTypePref
     */
    public function setPreferLevel($preferLevel = 'Preferred')
    {
        // validation for constraint: enumeration
        if (!\EnumType\PreferLevelType::valueIsValid($preferLevel)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $preferLevel, implode(', ', \EnumType\PreferLevelType::getValidValues())), __LINE__);
        }
        $this->PreferLevel = $preferLevel;
        return $this;
    }
    /**
     * Get WideBody value
     * @return bool|null
     */
    public function getWideBody()
    {
        return $this->WideBody;
    }
    /**
     * Set WideBody value
     * @param bool $wideBody
     * @return \StructType\EquipmentTypePref
     */
    public function setWideBody($wideBody = null)
    {
        $this->WideBody = $wideBody;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EquipmentTypePref
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
