<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LastMinuteDiscountRangeType StructType
 * @subpackage Structs
 */
class LastMinuteDiscountRangeType extends AbstractStructBase
{
    /**
     * The MinAdvanceBookingOffset
     * @var string
     */
    public $MinAdvanceBookingOffset;
    /**
     * The MaxAdvanceBookingOffset
     * @var string
     */
    public $MaxAdvanceBookingOffset;
    /**
     * The MinDiscountPercent
     * @var float
     */
    public $MinDiscountPercent;
    /**
     * The MaxDiscountPercent
     * @var float
     */
    public $MaxDiscountPercent;
    /**
     * Constructor method for LastMinuteDiscountRangeType
     * @uses LastMinuteDiscountRangeType::setMinAdvanceBookingOffset()
     * @uses LastMinuteDiscountRangeType::setMaxAdvanceBookingOffset()
     * @uses LastMinuteDiscountRangeType::setMinDiscountPercent()
     * @uses LastMinuteDiscountRangeType::setMaxDiscountPercent()
     * @param string $minAdvanceBookingOffset
     * @param string $maxAdvanceBookingOffset
     * @param float $minDiscountPercent
     * @param float $maxDiscountPercent
     */
    public function __construct($minAdvanceBookingOffset = null, $maxAdvanceBookingOffset = null, $minDiscountPercent = null, $maxDiscountPercent = null)
    {
        $this
            ->setMinAdvanceBookingOffset($minAdvanceBookingOffset)
            ->setMaxAdvanceBookingOffset($maxAdvanceBookingOffset)
            ->setMinDiscountPercent($minDiscountPercent)
            ->setMaxDiscountPercent($maxDiscountPercent);
    }
    /**
     * Get MinAdvanceBookingOffset value
     * @return string|null
     */
    public function getMinAdvanceBookingOffset()
    {
        return $this->MinAdvanceBookingOffset;
    }
    /**
     * Set MinAdvanceBookingOffset value
     * @param string $minAdvanceBookingOffset
     * @return \StructType\LastMinuteDiscountRangeType
     */
    public function setMinAdvanceBookingOffset($minAdvanceBookingOffset = null)
    {
        // validation for constraint: string
        if (!is_null($minAdvanceBookingOffset) && !is_string($minAdvanceBookingOffset)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($minAdvanceBookingOffset)), __LINE__);
        }
        $this->MinAdvanceBookingOffset = $minAdvanceBookingOffset;
        return $this;
    }
    /**
     * Get MaxAdvanceBookingOffset value
     * @return string|null
     */
    public function getMaxAdvanceBookingOffset()
    {
        return $this->MaxAdvanceBookingOffset;
    }
    /**
     * Set MaxAdvanceBookingOffset value
     * @param string $maxAdvanceBookingOffset
     * @return \StructType\LastMinuteDiscountRangeType
     */
    public function setMaxAdvanceBookingOffset($maxAdvanceBookingOffset = null)
    {
        // validation for constraint: string
        if (!is_null($maxAdvanceBookingOffset) && !is_string($maxAdvanceBookingOffset)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maxAdvanceBookingOffset)), __LINE__);
        }
        $this->MaxAdvanceBookingOffset = $maxAdvanceBookingOffset;
        return $this;
    }
    /**
     * Get MinDiscountPercent value
     * @return float|null
     */
    public function getMinDiscountPercent()
    {
        return $this->MinDiscountPercent;
    }
    /**
     * Set MinDiscountPercent value
     * @param float $minDiscountPercent
     * @return \StructType\LastMinuteDiscountRangeType
     */
    public function setMinDiscountPercent($minDiscountPercent = null)
    {
        $this->MinDiscountPercent = $minDiscountPercent;
        return $this;
    }
    /**
     * Get MaxDiscountPercent value
     * @return float|null
     */
    public function getMaxDiscountPercent()
    {
        return $this->MaxDiscountPercent;
    }
    /**
     * Set MaxDiscountPercent value
     * @param float $maxDiscountPercent
     * @return \StructType\LastMinuteDiscountRangeType
     */
    public function setMaxDiscountPercent($maxDiscountPercent = null)
    {
        $this->MaxDiscountPercent = $maxDiscountPercent;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LastMinuteDiscountRangeType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
