<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Policies StructType
 * @subpackage Structs
 */
class Policies extends AbstractStructBase
{
    /**
     * The SendPolicies
     * Meta informations extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $SendPolicies;
    /**
     * Constructor method for Policies
     * @uses Policies::setSendPolicies()
     * @param bool $sendPolicies
     */
    public function __construct($sendPolicies = true)
    {
        $this
            ->setSendPolicies($sendPolicies);
    }
    /**
     * Get SendPolicies value
     * @return bool|null
     */
    public function getSendPolicies()
    {
        return $this->SendPolicies;
    }
    /**
     * Set SendPolicies value
     * @param bool $sendPolicies
     * @return \StructType\Policies
     */
    public function setSendPolicies($sendPolicies = true)
    {
        $this->SendPolicies = $sendPolicies;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Policies
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
