<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PromotionsType StructType
 * @subpackage Structs
 */
class PromotionsType extends AbstractStructBase
{
    /**
     * The RateDiscount
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RateDiscountType[]
     */
    public $RateDiscount;
    /**
     * The LastUpdated
     * @var string
     */
    public $LastUpdated;
    /**
     * Constructor method for PromotionsType
     * @uses PromotionsType::setRateDiscount()
     * @uses PromotionsType::setLastUpdated()
     * @param \StructType\RateDiscountType[] $rateDiscount
     * @param string $lastUpdated
     */
    public function __construct(array $rateDiscount = array(), $lastUpdated = null)
    {
        $this
            ->setRateDiscount($rateDiscount)
            ->setLastUpdated($lastUpdated);
    }
    /**
     * Get RateDiscount value
     * @return \StructType\RateDiscountType[]|null
     */
    public function getRateDiscount()
    {
        return $this->RateDiscount;
    }
    /**
     * Set RateDiscount value
     * @throws \InvalidArgumentException
     * @param \StructType\RateDiscountType[] $rateDiscount
     * @return \StructType\PromotionsType
     */
    public function setRateDiscount(array $rateDiscount = array())
    {
        foreach ($rateDiscount as $promotionsTypeRateDiscountItem) {
            // validation for constraint: itemType
            if (!$promotionsTypeRateDiscountItem instanceof \StructType\RateDiscountType) {
                throw new \InvalidArgumentException(sprintf('The RateDiscount property can only contain items of \StructType\RateDiscountType, "%s" given', is_object($promotionsTypeRateDiscountItem) ? get_class($promotionsTypeRateDiscountItem) : gettype($promotionsTypeRateDiscountItem)), __LINE__);
            }
        }
        $this->RateDiscount = $rateDiscount;
        return $this;
    }
    /**
     * Add item to RateDiscount value
     * @throws \InvalidArgumentException
     * @param \StructType\RateDiscountType $item
     * @return \StructType\PromotionsType
     */
    public function addToRateDiscount(\StructType\RateDiscountType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RateDiscountType) {
            throw new \InvalidArgumentException(sprintf('The RateDiscount property can only contain items of \StructType\RateDiscountType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RateDiscount[] = $item;
        return $this;
    }
    /**
     * Get LastUpdated value
     * @return string|null
     */
    public function getLastUpdated()
    {
        return $this->LastUpdated;
    }
    /**
     * Set LastUpdated value
     * @param string $lastUpdated
     * @return \StructType\PromotionsType
     */
    public function setLastUpdated($lastUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($lastUpdated) && !is_string($lastUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastUpdated)), __LINE__);
        }
        $this->LastUpdated = $lastUpdated;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PromotionsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
