<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PropertyManagerRequests StructType
 * @subpackage Structs
 */
class PropertyManagerRequests extends AbstractStructBase
{
    /**
     * The PropertyManagerRequest
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PropertyManagerRequestType[]
     */
    public $PropertyManagerRequest;
    /**
     * Constructor method for PropertyManagerRequests
     * @uses PropertyManagerRequests::setPropertyManagerRequest()
     * @param \StructType\PropertyManagerRequestType[] $propertyManagerRequest
     */
    public function __construct(array $propertyManagerRequest = array())
    {
        $this
            ->setPropertyManagerRequest($propertyManagerRequest);
    }
    /**
     * Get PropertyManagerRequest value
     * @return \StructType\PropertyManagerRequestType[]|null
     */
    public function getPropertyManagerRequest()
    {
        return $this->PropertyManagerRequest;
    }
    /**
     * Set PropertyManagerRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\PropertyManagerRequestType[] $propertyManagerRequest
     * @return \StructType\PropertyManagerRequests
     */
    public function setPropertyManagerRequest(array $propertyManagerRequest = array())
    {
        foreach ($propertyManagerRequest as $propertyManagerRequestsPropertyManagerRequestItem) {
            // validation for constraint: itemType
            if (!$propertyManagerRequestsPropertyManagerRequestItem instanceof \StructType\PropertyManagerRequestType) {
                throw new \InvalidArgumentException(sprintf('The PropertyManagerRequest property can only contain items of \StructType\PropertyManagerRequestType, "%s" given', is_object($propertyManagerRequestsPropertyManagerRequestItem) ? get_class($propertyManagerRequestsPropertyManagerRequestItem) : gettype($propertyManagerRequestsPropertyManagerRequestItem)), __LINE__);
            }
        }
        $this->PropertyManagerRequest = $propertyManagerRequest;
        return $this;
    }
    /**
     * Add item to PropertyManagerRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\PropertyManagerRequestType $item
     * @return \StructType\PropertyManagerRequests
     */
    public function addToPropertyManagerRequest(\StructType\PropertyManagerRequestType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PropertyManagerRequestType) {
            throw new \InvalidArgumentException(sprintf('The PropertyManagerRequest property can only contain items of \StructType\PropertyManagerRequestType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PropertyManagerRequest[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PropertyManagerRequests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
