<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoomCountType StructType
 * @subpackage Structs
 */
class RoomCountType extends AbstractStructBase
{
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * The Min
     * @var float
     */
    public $Min;
    /**
     * The Max
     * @var float
     */
    public $Max;
    /**
     * The Fixed
     * @var float
     */
    public $Fixed;
    /**
     * Constructor method for RoomCountType
     * @uses RoomCountType::setCode()
     * @uses RoomCountType::setMin()
     * @uses RoomCountType::setMax()
     * @uses RoomCountType::setFixed()
     * @param string $code
     * @param float $min
     * @param float $max
     * @param float $fixed
     */
    public function __construct($code = null, $min = null, $max = null, $fixed = null)
    {
        $this
            ->setCode($code)
            ->setMin($min)
            ->setMax($max)
            ->setFixed($fixed);
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\RoomCountType
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Min value
     * @return float|null
     */
    public function getMin()
    {
        return $this->Min;
    }
    /**
     * Set Min value
     * @param float $min
     * @return \StructType\RoomCountType
     */
    public function setMin($min = null)
    {
        $this->Min = $min;
        return $this;
    }
    /**
     * Get Max value
     * @return float|null
     */
    public function getMax()
    {
        return $this->Max;
    }
    /**
     * Set Max value
     * @param float $max
     * @return \StructType\RoomCountType
     */
    public function setMax($max = null)
    {
        $this->Max = $max;
        return $this;
    }
    /**
     * Get Fixed value
     * @return float|null
     */
    public function getFixed()
    {
        return $this->Fixed;
    }
    /**
     * Set Fixed value
     * @param float $fixed
     * @return \StructType\RoomCountType
     */
    public function setFixed($fixed = null)
    {
        $this->Fixed = $fixed;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RoomCountType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
