<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnitInfo StructType
 * @subpackage Structs
 */
class UnitInfo extends AbstractStructBase
{
    /**
     * The SendData
     * Meta informations extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $SendData;
    /**
     * Constructor method for UnitInfo
     * @uses UnitInfo::setSendData()
     * @param bool $sendData
     */
    public function __construct($sendData = true)
    {
        $this
            ->setSendData($sendData);
    }
    /**
     * Get SendData value
     * @return bool|null
     */
    public function getSendData()
    {
        return $this->SendData;
    }
    /**
     * Set SendData value
     * @param bool $sendData
     * @return \StructType\UnitInfo
     */
    public function setSendData($sendData = true)
    {
        $this->SendData = $sendData;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UnitInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
