<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnitReservationType StructType
 * @subpackage Structs
 */
class UnitReservationType extends AbstractStructBase
{
    /**
     * The UniqueID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\UniqueID_Type
     */
    public $UniqueID;
    /**
     * The UnitStays
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfUnitStaysTypeUnitStay
     */
    public $UnitStays;
    /**
     * The Services
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfServicesTypeService
     */
    public $Services;
    /**
     * The ResGuests
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfResGuestsTypeResGuest
     */
    public $ResGuests;
    /**
     * The ResGlobalInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\EVRN_ResGlobalInfoType
     */
    public $ResGlobalInfo;
    /**
     * The WrittenConfInst
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\WrittenConfInstType
     */
    public $WrittenConfInst;
    /**
     * The TPA_Extensions
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TPA_Extensions_Type
     */
    public $TPA_Extensions;
    /**
     * The RoomStayReservation
     * @var bool
     */
    public $RoomStayReservation;
    /**
     * The CreateDateTime
     * @var string
     */
    public $CreateDateTime;
    /**
     * The CreatorID
     * @var string
     */
    public $CreatorID;
    /**
     * The LastModifyDateTime
     * @var string
     */
    public $LastModifyDateTime;
    /**
     * The LastModifierID
     * @var string
     */
    public $LastModifierID;
    /**
     * The ResStatus
     * @var string
     */
    public $ResStatus;
    /**
     * The SourceCategory
     * @var string
     */
    public $SourceCategory;
    /**
     * The SourceSubCategory
     * @var string
     */
    public $SourceSubCategory;
    /**
     * The CampaignID
     * @var int
     */
    public $CampaignID;
    /**
     * Constructor method for UnitReservationType
     * @uses UnitReservationType::setUniqueID()
     * @uses UnitReservationType::setUnitStays()
     * @uses UnitReservationType::setServices()
     * @uses UnitReservationType::setResGuests()
     * @uses UnitReservationType::setResGlobalInfo()
     * @uses UnitReservationType::setWrittenConfInst()
     * @uses UnitReservationType::setTPA_Extensions()
     * @uses UnitReservationType::setRoomStayReservation()
     * @uses UnitReservationType::setCreateDateTime()
     * @uses UnitReservationType::setCreatorID()
     * @uses UnitReservationType::setLastModifyDateTime()
     * @uses UnitReservationType::setLastModifierID()
     * @uses UnitReservationType::setResStatus()
     * @uses UnitReservationType::setSourceCategory()
     * @uses UnitReservationType::setSourceSubCategory()
     * @uses UnitReservationType::setCampaignID()
     * @param \StructType\UniqueID_Type $uniqueID
     * @param \ArrayType\ArrayOfUnitStaysTypeUnitStay $unitStays
     * @param \ArrayType\ArrayOfServicesTypeService $services
     * @param \ArrayType\ArrayOfResGuestsTypeResGuest $resGuests
     * @param \StructType\EVRN_ResGlobalInfoType $resGlobalInfo
     * @param \StructType\WrittenConfInstType $writtenConfInst
     * @param \StructType\TPA_Extensions_Type $tPA_Extensions
     * @param bool $roomStayReservation
     * @param string $createDateTime
     * @param string $creatorID
     * @param string $lastModifyDateTime
     * @param string $lastModifierID
     * @param string $resStatus
     * @param string $sourceCategory
     * @param string $sourceSubCategory
     * @param int $campaignID
     */
    public function __construct(\StructType\UniqueID_Type $uniqueID = null, \ArrayType\ArrayOfUnitStaysTypeUnitStay $unitStays = null, \ArrayType\ArrayOfServicesTypeService $services = null, \ArrayType\ArrayOfResGuestsTypeResGuest $resGuests = null, \StructType\EVRN_ResGlobalInfoType $resGlobalInfo = null, \StructType\WrittenConfInstType $writtenConfInst = null, \StructType\TPA_Extensions_Type $tPA_Extensions = null, $roomStayReservation = null, $createDateTime = null, $creatorID = null, $lastModifyDateTime = null, $lastModifierID = null, $resStatus = null, $sourceCategory = null, $sourceSubCategory = null, $campaignID = null)
    {
        $this
            ->setUniqueID($uniqueID)
            ->setUnitStays($unitStays)
            ->setServices($services)
            ->setResGuests($resGuests)
            ->setResGlobalInfo($resGlobalInfo)
            ->setWrittenConfInst($writtenConfInst)
            ->setTPA_Extensions($tPA_Extensions)
            ->setRoomStayReservation($roomStayReservation)
            ->setCreateDateTime($createDateTime)
            ->setCreatorID($creatorID)
            ->setLastModifyDateTime($lastModifyDateTime)
            ->setLastModifierID($lastModifierID)
            ->setResStatus($resStatus)
            ->setSourceCategory($sourceCategory)
            ->setSourceSubCategory($sourceSubCategory)
            ->setCampaignID($campaignID);
    }
    /**
     * Get UniqueID value
     * @return \StructType\UniqueID_Type|null
     */
    public function getUniqueID()
    {
        return $this->UniqueID;
    }
    /**
     * Set UniqueID value
     * @param \StructType\UniqueID_Type $uniqueID
     * @return \StructType\UnitReservationType
     */
    public function setUniqueID(\StructType\UniqueID_Type $uniqueID = null)
    {
        $this->UniqueID = $uniqueID;
        return $this;
    }
    /**
     * Get UnitStays value
     * @return \ArrayType\ArrayOfUnitStaysTypeUnitStay|null
     */
    public function getUnitStays()
    {
        return $this->UnitStays;
    }
    /**
     * Set UnitStays value
     * @param \ArrayType\ArrayOfUnitStaysTypeUnitStay $unitStays
     * @return \StructType\UnitReservationType
     */
    public function setUnitStays(\ArrayType\ArrayOfUnitStaysTypeUnitStay $unitStays = null)
    {
        $this->UnitStays = $unitStays;
        return $this;
    }
    /**
     * Get Services value
     * @return \ArrayType\ArrayOfServicesTypeService|null
     */
    public function getServices()
    {
        return $this->Services;
    }
    /**
     * Set Services value
     * @param \ArrayType\ArrayOfServicesTypeService $services
     * @return \StructType\UnitReservationType
     */
    public function setServices(\ArrayType\ArrayOfServicesTypeService $services = null)
    {
        $this->Services = $services;
        return $this;
    }
    /**
     * Get ResGuests value
     * @return \ArrayType\ArrayOfResGuestsTypeResGuest|null
     */
    public function getResGuests()
    {
        return $this->ResGuests;
    }
    /**
     * Set ResGuests value
     * @param \ArrayType\ArrayOfResGuestsTypeResGuest $resGuests
     * @return \StructType\UnitReservationType
     */
    public function setResGuests(\ArrayType\ArrayOfResGuestsTypeResGuest $resGuests = null)
    {
        $this->ResGuests = $resGuests;
        return $this;
    }
    /**
     * Get ResGlobalInfo value
     * @return \StructType\EVRN_ResGlobalInfoType|null
     */
    public function getResGlobalInfo()
    {
        return $this->ResGlobalInfo;
    }
    /**
     * Set ResGlobalInfo value
     * @param \StructType\EVRN_ResGlobalInfoType $resGlobalInfo
     * @return \StructType\UnitReservationType
     */
    public function setResGlobalInfo(\StructType\EVRN_ResGlobalInfoType $resGlobalInfo = null)
    {
        $this->ResGlobalInfo = $resGlobalInfo;
        return $this;
    }
    /**
     * Get WrittenConfInst value
     * @return \StructType\WrittenConfInstType|null
     */
    public function getWrittenConfInst()
    {
        return $this->WrittenConfInst;
    }
    /**
     * Set WrittenConfInst value
     * @param \StructType\WrittenConfInstType $writtenConfInst
     * @return \StructType\UnitReservationType
     */
    public function setWrittenConfInst(\StructType\WrittenConfInstType $writtenConfInst = null)
    {
        $this->WrittenConfInst = $writtenConfInst;
        return $this;
    }
    /**
     * Get TPA_Extensions value
     * @return \StructType\TPA_Extensions_Type|null
     */
    public function getTPA_Extensions()
    {
        return $this->TPA_Extensions;
    }
    /**
     * Set TPA_Extensions value
     * @param \StructType\TPA_Extensions_Type $tPA_Extensions
     * @return \StructType\UnitReservationType
     */
    public function setTPA_Extensions(\StructType\TPA_Extensions_Type $tPA_Extensions = null)
    {
        $this->TPA_Extensions = $tPA_Extensions;
        return $this;
    }
    /**
     * Get RoomStayReservation value
     * @return bool|null
     */
    public function getRoomStayReservation()
    {
        return $this->RoomStayReservation;
    }
    /**
     * Set RoomStayReservation value
     * @param bool $roomStayReservation
     * @return \StructType\UnitReservationType
     */
    public function setRoomStayReservation($roomStayReservation = null)
    {
        $this->RoomStayReservation = $roomStayReservation;
        return $this;
    }
    /**
     * Get CreateDateTime value
     * @return string|null
     */
    public function getCreateDateTime()
    {
        return $this->CreateDateTime;
    }
    /**
     * Set CreateDateTime value
     * @param string $createDateTime
     * @return \StructType\UnitReservationType
     */
    public function setCreateDateTime($createDateTime = null)
    {
        // validation for constraint: string
        if (!is_null($createDateTime) && !is_string($createDateTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($createDateTime)), __LINE__);
        }
        $this->CreateDateTime = $createDateTime;
        return $this;
    }
    /**
     * Get CreatorID value
     * @return string|null
     */
    public function getCreatorID()
    {
        return $this->CreatorID;
    }
    /**
     * Set CreatorID value
     * @param string $creatorID
     * @return \StructType\UnitReservationType
     */
    public function setCreatorID($creatorID = null)
    {
        // validation for constraint: string
        if (!is_null($creatorID) && !is_string($creatorID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($creatorID)), __LINE__);
        }
        $this->CreatorID = $creatorID;
        return $this;
    }
    /**
     * Get LastModifyDateTime value
     * @return string|null
     */
    public function getLastModifyDateTime()
    {
        return $this->LastModifyDateTime;
    }
    /**
     * Set LastModifyDateTime value
     * @param string $lastModifyDateTime
     * @return \StructType\UnitReservationType
     */
    public function setLastModifyDateTime($lastModifyDateTime = null)
    {
        // validation for constraint: string
        if (!is_null($lastModifyDateTime) && !is_string($lastModifyDateTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastModifyDateTime)), __LINE__);
        }
        $this->LastModifyDateTime = $lastModifyDateTime;
        return $this;
    }
    /**
     * Get LastModifierID value
     * @return string|null
     */
    public function getLastModifierID()
    {
        return $this->LastModifierID;
    }
    /**
     * Set LastModifierID value
     * @param string $lastModifierID
     * @return \StructType\UnitReservationType
     */
    public function setLastModifierID($lastModifierID = null)
    {
        // validation for constraint: string
        if (!is_null($lastModifierID) && !is_string($lastModifierID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastModifierID)), __LINE__);
        }
        $this->LastModifierID = $lastModifierID;
        return $this;
    }
    /**
     * Get ResStatus value
     * @return string|null
     */
    public function getResStatus()
    {
        return $this->ResStatus;
    }
    /**
     * Set ResStatus value
     * @param string $resStatus
     * @return \StructType\UnitReservationType
     */
    public function setResStatus($resStatus = null)
    {
        // validation for constraint: string
        if (!is_null($resStatus) && !is_string($resStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($resStatus)), __LINE__);
        }
        $this->ResStatus = $resStatus;
        return $this;
    }
    /**
     * Get SourceCategory value
     * @return string|null
     */
    public function getSourceCategory()
    {
        return $this->SourceCategory;
    }
    /**
     * Set SourceCategory value
     * @param string $sourceCategory
     * @return \StructType\UnitReservationType
     */
    public function setSourceCategory($sourceCategory = null)
    {
        // validation for constraint: string
        if (!is_null($sourceCategory) && !is_string($sourceCategory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sourceCategory)), __LINE__);
        }
        $this->SourceCategory = $sourceCategory;
        return $this;
    }
    /**
     * Get SourceSubCategory value
     * @return string|null
     */
    public function getSourceSubCategory()
    {
        return $this->SourceSubCategory;
    }
    /**
     * Set SourceSubCategory value
     * @param string $sourceSubCategory
     * @return \StructType\UnitReservationType
     */
    public function setSourceSubCategory($sourceSubCategory = null)
    {
        // validation for constraint: string
        if (!is_null($sourceSubCategory) && !is_string($sourceSubCategory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sourceSubCategory)), __LINE__);
        }
        $this->SourceSubCategory = $sourceSubCategory;
        return $this;
    }
    /**
     * Get CampaignID value
     * @return int|null
     */
    public function getCampaignID()
    {
        return $this->CampaignID;
    }
    /**
     * Set CampaignID value
     * @param int $campaignID
     * @return \StructType\UnitReservationType
     */
    public function setCampaignID($campaignID = null)
    {
        // validation for constraint: int
        if (!is_null($campaignID) && !is_numeric($campaignID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($campaignID)), __LINE__);
        }
        $this->CampaignID = $campaignID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UnitReservationType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
