<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnitStayCandidateType StructType
 * @subpackage Structs
 */
class UnitStayCandidateType extends AbstractStructBase
{
    /**
     * The RoomCounts
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfRoomCountType
     */
    public $RoomCounts;
    /**
     * The BedCounts
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfBedCountType
     */
    public $BedCounts;
    /**
     * The GuestCounts
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GuestCountType
     */
    public $GuestCounts;
    /**
     * The PetsPolicies
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PetsPoliciesType
     */
    public $PetsPolicies;
    /**
     * The NumberFloors
     * @var int
     */
    public $NumberFloors;
    /**
     * The NonSmoking
     * @var bool
     */
    public $NonSmoking;
    /**
     * The AreaSquareFeet
     * @var int
     */
    public $AreaSquareFeet;
    /**
     * The MaxOccupancy
     * @var int
     */
    public $MaxOccupancy;
    /**
     * The WhenBuilt
     * @var string
     */
    public $WhenBuilt;
    /**
     * Constructor method for UnitStayCandidateType
     * @uses UnitStayCandidateType::setRoomCounts()
     * @uses UnitStayCandidateType::setBedCounts()
     * @uses UnitStayCandidateType::setGuestCounts()
     * @uses UnitStayCandidateType::setPetsPolicies()
     * @uses UnitStayCandidateType::setNumberFloors()
     * @uses UnitStayCandidateType::setNonSmoking()
     * @uses UnitStayCandidateType::setAreaSquareFeet()
     * @uses UnitStayCandidateType::setMaxOccupancy()
     * @uses UnitStayCandidateType::setWhenBuilt()
     * @param \ArrayType\ArrayOfRoomCountType $roomCounts
     * @param \ArrayType\ArrayOfBedCountType $bedCounts
     * @param \StructType\GuestCountType $guestCounts
     * @param \StructType\PetsPoliciesType $petsPolicies
     * @param int $numberFloors
     * @param bool $nonSmoking
     * @param int $areaSquareFeet
     * @param int $maxOccupancy
     * @param string $whenBuilt
     */
    public function __construct(\ArrayType\ArrayOfRoomCountType $roomCounts = null, \ArrayType\ArrayOfBedCountType $bedCounts = null, \StructType\GuestCountType $guestCounts = null, \StructType\PetsPoliciesType $petsPolicies = null, $numberFloors = null, $nonSmoking = null, $areaSquareFeet = null, $maxOccupancy = null, $whenBuilt = null)
    {
        $this
            ->setRoomCounts($roomCounts)
            ->setBedCounts($bedCounts)
            ->setGuestCounts($guestCounts)
            ->setPetsPolicies($petsPolicies)
            ->setNumberFloors($numberFloors)
            ->setNonSmoking($nonSmoking)
            ->setAreaSquareFeet($areaSquareFeet)
            ->setMaxOccupancy($maxOccupancy)
            ->setWhenBuilt($whenBuilt);
    }
    /**
     * Get RoomCounts value
     * @return \ArrayType\ArrayOfRoomCountType|null
     */
    public function getRoomCounts()
    {
        return $this->RoomCounts;
    }
    /**
     * Set RoomCounts value
     * @param \ArrayType\ArrayOfRoomCountType $roomCounts
     * @return \StructType\UnitStayCandidateType
     */
    public function setRoomCounts(\ArrayType\ArrayOfRoomCountType $roomCounts = null)
    {
        $this->RoomCounts = $roomCounts;
        return $this;
    }
    /**
     * Get BedCounts value
     * @return \ArrayType\ArrayOfBedCountType|null
     */
    public function getBedCounts()
    {
        return $this->BedCounts;
    }
    /**
     * Set BedCounts value
     * @param \ArrayType\ArrayOfBedCountType $bedCounts
     * @return \StructType\UnitStayCandidateType
     */
    public function setBedCounts(\ArrayType\ArrayOfBedCountType $bedCounts = null)
    {
        $this->BedCounts = $bedCounts;
        return $this;
    }
    /**
     * Get GuestCounts value
     * @return \StructType\GuestCountType|null
     */
    public function getGuestCounts()
    {
        return $this->GuestCounts;
    }
    /**
     * Set GuestCounts value
     * @param \StructType\GuestCountType $guestCounts
     * @return \StructType\UnitStayCandidateType
     */
    public function setGuestCounts(\StructType\GuestCountType $guestCounts = null)
    {
        $this->GuestCounts = $guestCounts;
        return $this;
    }
    /**
     * Get PetsPolicies value
     * @return \StructType\PetsPoliciesType|null
     */
    public function getPetsPolicies()
    {
        return $this->PetsPolicies;
    }
    /**
     * Set PetsPolicies value
     * @param \StructType\PetsPoliciesType $petsPolicies
     * @return \StructType\UnitStayCandidateType
     */
    public function setPetsPolicies(\StructType\PetsPoliciesType $petsPolicies = null)
    {
        $this->PetsPolicies = $petsPolicies;
        return $this;
    }
    /**
     * Get NumberFloors value
     * @return int|null
     */
    public function getNumberFloors()
    {
        return $this->NumberFloors;
    }
    /**
     * Set NumberFloors value
     * @param int $numberFloors
     * @return \StructType\UnitStayCandidateType
     */
    public function setNumberFloors($numberFloors = null)
    {
        // validation for constraint: int
        if (!is_null($numberFloors) && !is_numeric($numberFloors)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($numberFloors)), __LINE__);
        }
        $this->NumberFloors = $numberFloors;
        return $this;
    }
    /**
     * Get NonSmoking value
     * @return bool|null
     */
    public function getNonSmoking()
    {
        return $this->NonSmoking;
    }
    /**
     * Set NonSmoking value
     * @param bool $nonSmoking
     * @return \StructType\UnitStayCandidateType
     */
    public function setNonSmoking($nonSmoking = null)
    {
        $this->NonSmoking = $nonSmoking;
        return $this;
    }
    /**
     * Get AreaSquareFeet value
     * @return int|null
     */
    public function getAreaSquareFeet()
    {
        return $this->AreaSquareFeet;
    }
    /**
     * Set AreaSquareFeet value
     * @param int $areaSquareFeet
     * @return \StructType\UnitStayCandidateType
     */
    public function setAreaSquareFeet($areaSquareFeet = null)
    {
        // validation for constraint: int
        if (!is_null($areaSquareFeet) && !is_numeric($areaSquareFeet)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($areaSquareFeet)), __LINE__);
        }
        $this->AreaSquareFeet = $areaSquareFeet;
        return $this;
    }
    /**
     * Get MaxOccupancy value
     * @return int|null
     */
    public function getMaxOccupancy()
    {
        return $this->MaxOccupancy;
    }
    /**
     * Set MaxOccupancy value
     * @param int $maxOccupancy
     * @return \StructType\UnitStayCandidateType
     */
    public function setMaxOccupancy($maxOccupancy = null)
    {
        // validation for constraint: int
        if (!is_null($maxOccupancy) && !is_numeric($maxOccupancy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($maxOccupancy)), __LINE__);
        }
        $this->MaxOccupancy = $maxOccupancy;
        return $this;
    }
    /**
     * Get WhenBuilt value
     * @return string|null
     */
    public function getWhenBuilt()
    {
        return $this->WhenBuilt;
    }
    /**
     * Set WhenBuilt value
     * @param string $whenBuilt
     * @return \StructType\UnitStayCandidateType
     */
    public function setWhenBuilt($whenBuilt = null)
    {
        // validation for constraint: string
        if (!is_null($whenBuilt) && !is_string($whenBuilt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($whenBuilt)), __LINE__);
        }
        $this->WhenBuilt = $whenBuilt;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UnitStayCandidateType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
